---
layout: layouts/exercise_base.njk
exercise: 3
points: 5
---
<ol>
  <li><strong>Total Resistance</strong><br />
  Develop a program that calculates the total resistance of $n$ parallel
  resistors like in the schematic below.<br />

  <img src="https://upload.wikimedia.org/wikipedia/commons/0/09/Resistors_in_parallel.svg"
       alt="File:Resistors in parallel.svg" /><br />

  The program should use a separate function for the actual calculation.
    <ul>
      <li>In <code>main(.)</code>)
        deal with user input and output. Ask the user to
        enter the number of parallel resistors of the circuit
        and then ask for the resistance of each resistor using a
        <code>for</code> loop.
      </li>
      <li>The other function should take an array of resistances and the length
        of this array as input and return the total resistance.
      </li>
    </ul>
    The total resistance can be calculated with this formula:
    $$
    R_{total} = \frac{1}{\sum_{i=1}^n \frac{1}{R_i}}
    $$<br />
    Name the source file: <kbd>parallel_resistors.c</kbd>
  </li>
  <li><strong>Count Matching Elements</strong><br />
    Write a function <code>int countNumInArray(int array[], int dimension, int number)</code> that returns how many times the given number occurs in the array. For example
{% highlight "c" %}
int array[] = {4, 1, 7, 5, 4, 1, 4, 2, 7};
countNumInArray(array, 9, 5);  // returns 1
countNumInArray(array, 9, 4);  // returns 3
{% endhighlight %}
  </li>
  <li><strong>Find Maximum</strong><br />
    Write a function <code>int max(int array[], int dimension)</code> that takes
    an array of integers and its dimension and returns the array's highest
    number. Try to determine a way to figure out the
    number of elements in the array inside the function <code>max(.)</code>.
    You may
    assume that the passed array is never empty.
{% highlight "c" %}
int array[] = {4, 1, 7, 5, 4, 1, 4, 2, 7};
max(array, 9);  // returns 7
{% endhighlight %}
  </li>
  <li><strong>Determine Prefix</strong>
    Write a function <code>bool beginsWith(char prefix[], char string[])</code> that returns <code>true</code> if <code>prefix[]</code> is a prefix of <code>string[]</code>. For example
{% highlight "c" %}
char prefix1[] = "Al";
char string1[] = "Aline";
char string2[] = "Hello World!";
beginsWith(prefix, string1);  // returns `true`
beginsWith(prefix, string2);  // returns `false`
{% endhighlight %}
    Don't forget to <code>#include &lt;stdbool.h&gt;</code> in order to use the
    <code>bool</code> data type.
  </li>
  <li><!-- TODO: move to exercise sheet 1. -->
    <strong>Mathematical functions</strong><br />
    Write a program that prints the sine and cosine of all values between 0 and
    π in steps of 0.1. The last value must be π. All values
    should be fixed to 2 digits after the decimal point.
    <br />
    A sample run of this program:
<pre>
radians |  sine | cosine
------------------------
    0.0 |  0.00 |   1.00
    0.1 |  0.10 |   1.00
    0.2 |  0.20 |   0.98
[...]
    3.0 |  0.14 |  -0.99
    3.1 |  0.04 |  -1.00
   3.14 |  0.00 |  -1.00
</pre>

</ol>
